{-
Modified version of the KeymapTree.hs library from Tutorial 6
-}


module Extra.Trees ( Keymap, get, set, toList, fromList )

where

-- Modules for testing

import Data.List

-- The data type

data Ord k => Keymap k a = Node k a (Keymap k a) (Keymap k a)
                         | Leaf


toList :: Ord k => Keymap k a -> [(k,a)]
toList Leaf = []
toList (Node n1 n2 l r) = toList (l) ++ [(n1, n2)] ++ toList(r)

set :: Ord k => k -> a -> Keymap k a -> Keymap k a
set key value = f 
    where
      f Leaf = Node key value Leaf Leaf
      f (Node k v left right) | key == k  = Node k value left right
                              | key <= k  = Node k v (f left) right
                              | otherwise = Node k v left (f right)

get :: Ord k => k -> Keymap k a -> (k, a) -- the entirely modified search function
get key = f
    where
      f (Node k v (Node l ld ll lr) (Node r rd rl rr)) | (key > l) && (key < r)  = (k, v)
                                                       | key < k   = f (Node l ld ll lr)
                                                       | otherwise = f (Node r rd rl rr)
      f (Node k v (Leaf) (Node r rd rl rr)) | (key <= r) = (k, v)
                                            | otherwise = f (Node r rd rl rr)
      f (Node k v (Node l ld ll lr) (Leaf)) | (key >= l) = (k, v)
                                            | otherwise = f (Node l ld ll lr)
      f (Node k v (Leaf) (Leaf)) = (k, v)

fromList :: Ord k => [(k,a)] -> Keymap k a
fromList = foldr (uncurry set) Leaf
