{-
This script generates a mosaic and shows it to the screen. It works by calling functions from the "main"
Mosaics.hs script but instead of saving the result to a "bmp" file, it shows it to the screen using a
library I wrote for that purpose called MartoGraphics. The reason I didn't put that function into Mosaics.hs
is because I wrote the whole project under Windows and obviously the GLUT libraries are not compatible
with the DICE machines at school and thus this file MosaicDispay.hs won't work on them.

If you manipulate big files, you should use the GHC command +RTS -K100M or if you are on a Windows machine execute "RunDisplay.bat"
-}

import Mosaic hiding (main)
import Extra.MartoGraphics
import Extra.Types
import Extra.Bitmaps
import Extra.Trees
import Settings

main :: IO()
main = do putStr ("Opening " ++ file_name ++"\n")
          x <- readBmp file_name
          putStr ("Reading the database\n")
          datab <- readDB
          (Bmp w h _) <- return (x)
          tiles_in_height <- return(floor((fromIntegral h)*(fromIntegral tiles_in_width)*(fromIntegral tile_width)/((fromIntegral w)*(fromIntegral tile_height))))
          buffe1 <- return(resize (fromIntegral tiles_in_width) (fromIntegral tiles_in_height) x)
          putStr ("Generating...")
          buffe2 <- genmosaic w h tiles_in_height buffe1 datab
          buffe3 <- return(combine x (resize w h buffe2))
          buffe <- if ((fromIntegral w)<(fromIntegral window_width)) && ((fromIntegral h)<(fromIntegral window_height)) 
                    then return (buffe3)
                    else do putStr ("\nResizing output image so it would fit the screen")
                            woh <- return ((fromIntegral w) / (fromIntegral h))
                            nw <- return (woh * (fromIntegral window_height))
                            nh <- return ((fromIntegral window_width) / woh)
                            if ((fromIntegral w)>(fromIntegral window_width)) && ((nh < (fromIntegral window_height)) || ((fromIntegral w)>(fromIntegral h)))
                               then return(resize (fromIntegral window_width) (round (nh)) buffe3)
                               else return(resize (round (nw)) (fromIntegral window_height) buffe3)
          putStr ("\nDrawing to screen (this can take a while)...\n")
          drawbuffer buffe
          putStr ("Done\n")

