{-
Use this file to configure the behaviour of "Mosaic.hs"
-}

module Settings
    where

-- Some variables that could be tweaked, if you're typing names pay attention not to drop the quotes ""

file_name       = "pic.bmp"    -- the file name that would be turned into mosaics

db_name         = "imdb.cs"    -- the database file containing infotmation about the tiles

tiles_folder    = "tiles"      -- the folder when the tiles reside (this variable is only used for generating databases)

output_name     = "output.bmp" -- the file name of the new image after the mosaification

tiles_in_width  = 15           -- the number of tiles in the width of the mosaic. The programme will calculate the ->
------------------------------ -- number of tiles in the height so it could maintain both the aspect ratio of the ->
------------------------------ -- original image and the tiles. A big number can cuse an "out of memory" problem->
------------------------------ -- and ghc will close without notification.

tile_width      = 50           -- width and height of the tiles in the tiles folder. If there are tiles of different ->
tile_height     = 50           -- size, then they would be scaled so they'll fit those values


blending_per    = 40.0         -- the amount of detailes from the original image that would be merged with the final image in %

randomization   = 10           -- a colour offset for randomizing tiles (preventing a tile appearing a lot of times) ->
------------------------------ -- bigger number makes more random pictures, but their colour would be "shifted" too much ->
------------------------------ -- in order to match the source pixel colour. Smaller value will make more tiles repeat ->
------------------------------ -- more often, but their original colours will be closer to the source pixel


-- MosaicDisplay.hs settings -- those variables does not affect Main.hs and the saving of bmp files

window_width    = 640          -- the output window width - this variable is only used in "MosaicDisplay.hs" ->
window_height   = 480          -- the image produced by "MosaicDisplay.hs" will be scaled down to fit this value